<?php
/**
 * @package   Switips
 * @author    Outcode https://outcode.ru/
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/*
 *  Статусы:
 *
 *    1 = Pending
 *    2 = Confirmed
 *    3 = Cancelled
 *    4 = Refunded
 *    5 = Shipped
 *    6 = Paid
 *    7 = Complete
 *
 *
 *    "new", "paid", "canceled", "confirmed"
 *    jbdump($result);
*/


class Plgjshoppingorderswitipsstatus extends JPlugin {

  public function __construct(&$subject, $config){
    parent::__construct($subject, $config);
  }
  
  // administrator/components/com_jshopping/models/orders.php
  public function onAfterSaveOrder(&$order, &$file_generete_pdf_order){
    
    $uid = $this->getUid($order->order_id);
    $commission = $this->getCommission($order);
    $result = $this->sendToSwitips($uid, $order, [], $commission);

  }  
  
  // components/com_jshopping/models/orderchangestatus.php
  public function onAfterChangeOrderStatusAdmin(&$order_id, &$status, &$status_id, &$notify, &$comments, &$include_comment,	&$view_order, &$prev_order_status){
    
    $order = &JSFactory::getTable('order', 'jshop');
    $order->load($order_id);
    
    $order_other = $this->getOrder($order_id);
    $uid = $this->getUid($order_id);
    $commission = $this->getCommission($order);
    $result = $this->sendToSwitips($uid, $order, $order_other, $commission);
	}
  
  public function sendToSwitips($uid, $order, $order_other, $commission = 0){
    $switips = $this->getParams();

    if($uid == ''){ return; }
    if(intval($switips->sw_status) != 1){ return; }

    $status = 'new';
    switch (intval($order->order_status)) {
      case 1:
      $status = 'new';
      break;  
      case 2:
      $status = 'confirmed';
      break;        
      case 3:
      $status = 'canceled';
      break;
      case 4:
      $status = 'canceled';
      break;
      case 5:
      $status = 'new';
      break;        
      case 6:
      $status = 'paid';
      break; 
      case 7:
      $status = 'confirmed';
      break;
    }  

    $args = [      
      'secret_key' => $switips->key_api,
      'merchant_id' => $switips->merchant_id,
      'campaign_id' => 0,
      'category_id' => 0,
      'user_id' => $uid,    
      'transaction_id' => $order->order_id,
      'transaction_amount' => $order->order_total,
      'transaction_amount_currency' => $order->order_total,
      'currency' => (count($order_other) > 0) ? $order_other['currency_code_iso'] : $order->currency_code,   
      'tt_date' => (count($order_other) > 0) ? strtotime($order_other['order_date']) : strtotime($order->order_date),
      'stat' => $status, 
      'commission_amount' => $commission,
    ]; 

    JLoader::register('Switips', JPATH_ROOT . '/libraries/switipsapi/switips.php');    
    $SwitipsCls = new Switips($switips->url_api);    
    $send = $SwitipsCls->sendRequestPost($args);

    return $send;
  }  
  
  function getCommission(&$order){
    $db = &JFactory::getDBO();

    $return = 0;
    if(!$db->connected()) {
      return $return;
    }else{
      
      $products = $order->getAllItems();

      foreach($products as $product){
        $qty = round($product->product_quantity);
        $unit_price = $product->product_item_price; // Цена одной единицы товара
        
        $commission = $this->categoryCommissions($product->product_id, $unit_price);        
        
        $query = 'SELECT `commission` FROM  #__jshopping_products WHERE `product_id`='.intval($product->product_id);
        $db->setQuery($query);
        $result = $db->loadAssocList();   
        
        $tmp = (isset($result[0]['commission'])) ? $result[0]['commission'] : 0;
        $product_commission = $this->checCommission($tmp);      

        if($product_commission > 0){
          
          if(strpos($product_commission, '%') !== false){
            $product_commission = str_replace('%', '', $product_commission);
            $product_commission = ($unit_price/100)*$product_commission;          
          }
          
          $commission = $product_commission;        
        }

        $return += $qty * $commission;

      }

      return $return;
    } 
  }
  
  public function categoryCommissions($product_id, $unit_price){
    $db = &JFactory::getDBO();

    $query = "SELECT pr_cat.category_id, cat.commission FROM `#__jshopping_products_to_categories` AS pr_cat
              LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
              WHERE pr_cat.product_id=".(int)$product_id;
    $db->setQuery($query);
    $data = $db->loadAssocList();
    
    $catalog_commission = 0;
    $prev_commission = 0;
    $next_commission = 0;
    
    foreach($data as $d){
      $next_commission = $this->checCommission($d['commission']);
      
      if($next_commission == 0){
        continue;
      }

      if(strpos($next_commission, '%') !== false){
        $next_commission = str_replace('%', '', $next_commission);
        $next_commission = ($unit_price/100)*$next_commission; 
      }      
      
      // max значение
      $catalog_commission = ($next_commission > $prev_commission) ? $next_commission : $prev_commission;
      $prev_commission = $catalog_commission;
    }
    
    return $catalog_commission;
  }
  
  public function checCommission($value = 0){
    $pattern = '/[^0-9 %]+/msiu';
    if(preg_match($pattern, $value)){      
      return 0; // Найдены запрещенные символы
    }else{
      return str_replace(' ', '', $value);
    }  
  } 
  
  function getUid($order_id){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{  

      $query = 'SELECT `uid` FROM  #__switips_uid WHERE `order_id`='.intval($order_id);
      $db->setQuery($query);
      $result = $db->loadAssocList();  
      
      if(isset($result[0]['uid'])){
        return $result[0]['uid'];
      }else{
        return '';
      }
      
    } 
  } 
  
  function getOrder($order_id){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{  

      $query = 'SELECT * FROM  #__jshopping_orders WHERE `order_id`='.intval($order_id);
      $db->setQuery($query);
      $result = $db->loadAssocList();  
      
      if(isset($result[0]['order_id'])){
        return $result[0];
      }else{
        return [];
      }
      
    } 
  }  
  
  public function getParams(){
    $db = &JFactory::getDBO();
    
    if(!$db->connected()) {
      return null;
    }else{  
      $query = "SELECT `params` FROM  #__extensions WHERE `element`='com_switips'";
      $db->setQuery($query);
      $result = $db->loadAssocList(); 
      
      if(isset($result[0]['params'])){
        return json_decode($result[0]['params']);
      }      
    }   
  }

}


